aboutsummaryrefslogtreecommitdiff
path: root/sys/tools
diff options
context:
space:
mode:
authorKonstantin Belousov <kib@FreeBSD.org>2021-11-14 00:26:55 +0000
committerKonstantin Belousov <kib@FreeBSD.org>2021-12-06 18:46:49 +0000
commit98c8b6252496e874d337d9a7b565d9037609168f (patch)
tree97389d7a05a8b4ba83c81d63a13bff285244b19a /sys/tools
parent290e05dde058b50aec48464d7116a55c7417575e (diff)
downloadsrc-98c8b6252496e874d337d9a7b565d9037609168f.tar.gz
src-98c8b6252496e874d337d9a7b565d9037609168f.zip
vdso for ia32 on amd64
Reviewed by: emaste Discussed with: jrtc27 Tested by: pho Sponsored by: The FreeBSD Foundation MFC after: 1 month Differential revision: https://reviews.freebsd.org/D32960
Diffstat (limited to 'sys/tools')
-rw-r--r--sys/tools/amd64_ia32_vdso.sh53
1 files changed, 53 insertions, 0 deletions
diff --git a/sys/tools/amd64_ia32_vdso.sh b/sys/tools/amd64_ia32_vdso.sh
new file mode 100644
index 000000000000..15ad866b4471
--- /dev/null
+++ b/sys/tools/amd64_ia32_vdso.sh
@@ -0,0 +1,53 @@
+#!/bin/sh
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2021 The FreeBSD Foundation
+# All rights reserved.
+#
+# This software was developed by Konstantin Belousov <kib@FreeBSD.org>
+# under sponsorship from the FreeBSD Foundation.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+set -e
+
+${CC} -x assembler-with-cpp -DLOCORE -fPIC -nostdinc -c -m32 \
+ -o ia32_sigtramp.pico -I. -I"${S}" -include opt_global.h \
+ "${S}"/amd64/ia32/ia32_sigtramp.S
+
+${LD} --shared -Bsymbolic -soname="elf-vdso32.so.1" \
+ -T "${S}"/conf/vdso_amd64_ia32.ldscript \
+ --eh-frame-hdr --no-undefined -z rodynamic -z norelro -nmagic \
+ --hash-style=sysv --fatal-warnings --strip-all \
+ -o elf-vdso32.so.1 ia32_sigtramp.pico
+
+${CC} -x assembler-with-cpp -DLOCORE -fPIC -nostdinc -c \
+ -o elf-vdso32.so.o -I. -I"${S}" -include opt_global.h \
+ -DVDSO_NAME=elf_vdso32_so_1 -DVDSO_FILE=elf-vdso32.so.1 \
+ "${S}"/tools/vdso_wrap.S
+
+${NM} -D elf-vdso32.so.1 | ${AWK} \
+ '/__vdso_ia32_sigcode/{printf "#define VDSO_IA32_SIGCODE_OFFSET 0x%s\n",$1}
+ /__vdso_freebsd4_ia32_sigcode/{printf "#define VDSO_FREEBSD4_IA32_SIGCODE_OFFSET 0x%s\n",$1}
+ /__vdso_ia32_osigcode/{printf "#define VDSO_IA32_OSIGCODE_OFFSET 0x%s\n",$1}
+ /__vdso_lcall_tramp/{printf "#define VDSO_LCALL_TRAMP_OFFSET 0x%s\n",$1}' \
+ >vdso_ia32_offsets.h